#include "gd32f10x.h"
#include "boot.h"
#include "main.h"
#include "delay.h"
#include "fmc.h"
#include "w25q32.h"
#include <stdio.h>
#include "ota_message.h"
#define APP_PROGRAMMER_BLOCK 2   //W25Q32дŵλ

load_a load_A;       

//bootloader
void BootLoader_Brance(uint32_t app_byte)
{
	GD32_EraseFlash(GD32_A_START_PAGE,GD32_A_PAGE_NUM);//Aԭг
	for(uint8_t i=0;i<app_byte/1024;i++)
	{
		task_fwdgt_reload();
		uint8_t app_programmer[1024];
		memset(app_programmer,0,1024);
		uint32_t addr=APP_PROGRAMMER_BLOCK*64*1024+i*1024;   //w25q32еĵַ
		W25Q32_Read(app_programmer,addr,1024);               
		GD32_WriteFlash(GD32_A_SADDR+i*1024,(uint32_t *)&app_programmer,1024); //ݰҳд
	}
	//1024ݵд
	if(app_byte%1024!=0)
	{
		uint32_t startAddress=(app_byte/1024)*1024;
		uint8_t app_programmer[1024];
		uint32_t addr=APP_PROGRAMMER_BLOCK*64*1024+(app_byte/1024)*1024;   														//w25q32еĵַ
		memset(app_programmer,0,1024);
		W25Q32_Read(app_programmer,addr,app_byte%1024);																					
		GD32_WriteFlash(GD32_A_SADDR+(app_byte/1024)*1024,(uint32_t *)&app_programmer,app_byte%1024);
	}
	clear_ota_message_config_block();  
	LOAD_A(GD32_A_SADDR);
}


/*-------------------------------------------------*/
/*SP                                   */
/*  addrջָʼֵ                     */
/*ֵ                                       */
/*-------------------------------------------------*/
__asm void MSR_SP(uint32_t addr)
{
	MSR MSP, r0      
	BX r14             
}
/*-------------------------------------------------*/
/*תA                                */
/*  addrAʼַ                      */
/*ֵ                                       */
/*-------------------------------------------------*/
void LOAD_A(uint32_t addr)
{
	if((*(uint32_t *)addr>=0x20000000)&&(*(uint32_t *)addr<=0x20017FFF)){     
		MSR_SP(*(uint32_t *)addr);                                            
		load_A = (load_a)*(uint32_t *)(addr+4);                               
		BootLoader_Clear();                                                
		load_A();                                       
	}else ; 
}
/*-------------------------------------------------*/
/*Bʹõ                        */
/*                                         */
/*ֵ                                       */
/*-------------------------------------------------*/
void BootLoader_Clear(void)
{
	usart_disable(USART0);
	dma_channel_disable(DMA0, DMA_CH4);
	dma_deinit(DMA0, DMA_CH4);
	gpio_deinit(GPIOA);    
	gpio_deinit(GPIOB);    
}













