#include "gd32f10x.h"
#include "spi.h"

/*-------------------------------------------------*/
/*SPI0ʼ                               */
/*                                         */
/*ֵ                                       */
/*-------------------------------------------------*/
void SPI0_Init(void){
	
	spi_parameter_struct spi_parameter;                                             //ʼSPIĽṹ
	
	rcu_periph_clock_enable(RCU_SPI0);                                              //SPI0ʱ
	rcu_periph_clock_enable(RCU_GPIOA);                                             //GPIOAʱ
	
	gpio_init(GPIOA,GPIO_MODE_AF_PP,GPIO_OSPEED_50MHZ,GPIO_PIN_5|GPIO_PIN_7);       //PA5PA7
	gpio_init(GPIOA,GPIO_MODE_IN_FLOATING,GPIO_OSPEED_50MHZ,GPIO_PIN_6);            //PA6
	
	spi_i2s_deinit(SPI0);                                           //λSPI0
	spi_parameter.device_mode = SPI_MASTER;                         //ģʽ
	spi_parameter.trans_mode = SPI_TRANSMODE_FULLDUPLEX;            //˫˫ȫ˫
	spi_parameter.frame_size = SPI_FRAMESIZE_8BIT;                  //ݿ8λһֽ
	spi_parameter.nss = SPI_NSS_SOFT;                               //NSS
	spi_parameter.endian = SPI_ENDIAN_MSB;                          //λʼ
	spi_parameter.clock_polarity_phase = SPI_CK_PL_LOW_PH_1EDGE;    //ģʽ0
	spi_parameter.prescale = SPI_PSC_2;                             //2Ƶ
	spi_init(SPI0,&spi_parameter);                                  //ʼSPI0
	spi_enable(SPI0);	                                            //SPI0
}  
/*-------------------------------------------------*/
/*SPIշһֽ                          */
/*  txdҪ͵                        */
/*ֵյ                             */
/*-------------------------------------------------*/
uint8_t SPI0_ReadWriteByte(uint8_t txd)
{
	while(spi_i2s_flag_get(SPI0,SPI_FLAG_TBE)!=1);  //ȵͻ
	spi_i2s_data_transmit(SPI0,txd);                //
	while(spi_i2s_flag_get(SPI0,SPI_FLAG_RBNE)!=1); //ȴջ
	return spi_i2s_data_receive(SPI0);              //ؽյ
}
/*-------------------------------------------------*/
/*SPI                                */
/*  wdataָ  datalenͳ   */
/*ֵ                                       */
/*-------------------------------------------------*/
void SPI0_Write(uint8_t *wdata, uint16_t datalen)
{
	uint16_t i;                         //forѭ
	
	for(i=0;i<datalen;i++){             //ѭdatalenΣһֽһֽڷ
		SPI0_ReadWriteByte(wdata[i]);   //һֽ
	}
}
/*-------------------------------------------------*/
/*SPI                              */
/*  rdataջ  datalenճ     */
/*ֵ                                       */
/*-------------------------------------------------*/
void SPI0_Read(uint8_t *rdata, uint16_t datalen)
{
	uint16_t i;                                   //forѭ
	
	for(i=0;i<datalen;i++){                       //ѭdatalenΣһֽһֽڽ
		rdata[i] = SPI0_ReadWriteByte(0xff);      //ձһֽ
	}
}


