#include "device_message.h"
#include "gd32f10x.h"
#include "string.h"
int parseIntField(const char *data, const char *field);
void parseStringField(const char *data, const char *field, char *value);
void addDevice(char *deviceString);
void addSensorListParams(char *paramString, DEVICE_PARAMS *device);
void addCommandListParams(char *paramString, DEVICE_PARAMS *device);
GATEWAY_PARAMS gateway_config_params = {0};

GATEWAY_PARAMS *get_gateway_config_params()
{
    return &gateway_config_params;
}
/***
***ҪΪṹز㣬豸㣬Բ
***䲻jsonjson̫ùؼƥȥjson'}'ͺһλ']'ȥжδڲһһڲݽ'}'Ϊ'A'ֹȥҽʱҵڲ
***/
//Ϣ
int addGatewayParams(char *gatewayString)
{
	  parseStringField(gatewayString, "\"commandTopic\":\"", (char *)&gateway_config_params.commandTopic);
		parseStringField(gatewayString, "\"messageTopic\":\"", (char *)&gateway_config_params.messageTopic);
	  parseStringField(gatewayString,"\"username\":\"",(char *)&gateway_config_params.mqttUserName);
		parseStringField(gatewayString,"\"password\":\"",(char *)&gateway_config_params.mqttPassword);
		
	 
    parseStringField(gatewayString, "\"deviceId\":\"", (char *)&gateway_config_params.deviceId);
    parseStringField(gatewayString, "\"host\":\"", (char *)&gateway_config_params.host);
    gateway_config_params.port = parseIntField(gatewayString, "\"port\":");
		
    gateway_config_params.pollTime = parseIntField(gatewayString, "\"pollTime\":");
		gateway_config_params.baudrate=parseIntField(gatewayString, "\"baudrate\":");
		gateway_config_params.checkBit=parseIntField(gatewayString, "\"checkBit\":");
		gateway_config_params.dataBits=parseIntField(gatewayString, "\"dataBit\":");
		gateway_config_params.stopBit=parseIntField(gatewayString, "\"stopBit\":");
		gateway_config_params.inboundTime=parseIntField(gatewayString, "\"inboundTime\":");
		char *deviceString = strstr(gatewayString, "deviceList");//ҵ豸λ
    while (1)
    {
				addDevice(deviceString); // ˽ڵ¹豸Ϣ
				deviceString=deviceString;//deviceStringݱڲݸд˽һؼ
				deviceString = strstr(deviceString, "}");          // ƶһ
				deviceString[0]='A';
				deviceString++;
			  if(deviceString[0]==']')
				{
						break;
				}
    }
}
void addGatewayParamsJson(char *gatewayString)
{
	
}
//µ豸
//ӦΪǶ׽ṹҵڲ{}ֵдԱⲿĽṹȥѰ
void addDevice(char *deviceString)
{
	char *paramString = (char *)deviceString; // ָ
  DEVICE_PARAMS *newDevicePage = (DEVICE_PARAMS *)malloc(sizeof(DEVICE_PARAMS));
	newDevicePage->nextDevice = NULL;
	parseStringField(deviceString, "\"deviceId\":\"", (char *)&newDevicePage->deviceID);
  newDevicePage->protocol = parseIntField(deviceString, "\"protocol\":");
  newDevicePage->params = (PARAMS_PROTOCOL_COMMAND *)malloc(sizeof(PARAMS_PROTOCOL_COMMAND));	
	paramString = strstr(paramString, "\"sensorData\":["); // ҵýڵѯϷ
	if(paramString!=NULL)
	{
		while(1)
		{
			 addSensorListParams(paramString, newDevicePage); // һԲظڸ
			 paramString = strstr(paramString, "}");          // ƶһ
			 paramString[0]='A';
			 paramString++;
			 if (paramString[0] == ']')
			 {
				 paramString = (char *)deviceString;//豸ڵԣָָ豸һʼλãֹjsonµsensorListcommandData
				 break;
			 }
		}
	}
		if(newDevicePage->protocol==MODBUS)  //ΪmodbusĻдָ
		{
		paramString=deviceString;                                //ƶʼĵط
		newDevicePage->MDBbigLittleFormat = parseIntField(paramString, "\"bigLittleFormat\":");
    newDevicePage->MDBdataType= parseIntField(paramString, "\"dataType\":");
		paramString = strstr(paramString, "\"commandData\":["); // ҵѯд
		if(paramString!=NULL)//ܲcommandData
		{
			while(1)
			{
				addCommandListParams(paramString, newDevicePage);
				paramString = strstr(paramString, "}");
				paramString[0]='A';
				paramString++;
				if (paramString[0] == ']')
				{
					paramString = (char *)deviceString;
					break;
				}
			}
		}
	}
	if(gateway_config_params.device_params==NULL)
	{
		gateway_config_params.device_params=newDevicePage;
	}else
	{
		DEVICE_PARAMS *current=gateway_config_params.device_params;
    while (current->nextDevice != NULL)
    {
      current = current->nextDevice;
    }
      current->nextDevice = newDevicePage;		
	}
}
/**
 * @brief  ַparamString,ݱ浽豸ṹ£˴sensorList
 * @param  uint8_t *paramStringַ,DEVICE_PARAMS *deviceڵϢ
 * @retval 
 */
void addSensorListParams(char *paramString, DEVICE_PARAMS *device)
{
    switch (device->protocol)
    {
    case DLT645_97:
    case DLT645_07:
		{
        READ_DLT645_COMMAND *read_dlt645_command = malloc(sizeof(READ_DLT645_COMMAND));
				READ_MODBUS_COMMAND *read_modbus_command =NULL;
        read_dlt645_command->Identification = parseIntField(paramString, "\"identifier645\":");
        parseStringField(paramString, "\"identifier\":\"", (char *)&read_dlt645_command->keyword);
        char *string = malloc(13);
        parseStringField(paramString, "\"deviceID645\":\"", string);
        for (int j = 0; j < 6; j++)
        {
          uint8_t byte;
          sscanf((const char *)&string[j * 2], "%2hhx", &byte);
          read_dlt645_command->deviceID645[j]=byte;
        }
        free(string);
        if (device->params->node_read_dlt645_command == NULL)
        {
            device->params->node_read_dlt645_command = read_dlt645_command;
        }
        else
        {
            READ_DLT645_COMMAND *current = device->params->node_read_dlt645_command;
            while (current->nextParams != NULL)
            {
                current = current->nextParams;
            }
            current->nextParams = read_dlt645_command;
        }
			}
        break;
    case MODBUS:
		{
        READ_MODBUS_COMMAND *read_modbus_command = malloc(sizeof(READ_MODBUS_COMMAND));
				READ_DLT645_COMMAND *read_dlt645_command = NULL;
				parseStringField(paramString,"\"identifier\":\"",(char *)&read_modbus_command->keyword);
        read_modbus_command->decimalPoint = parseIntField(paramString, "\"precise\":");
        read_modbus_command->functionCode = parseIntField(paramString, "\"rFunctionCode\":");
        read_modbus_command->slaveAddress = parseIntField(paramString, "\"slaveAddress\":");
        read_modbus_command->registerAddress = parseIntField(paramString, "\"registerAddress\":");
        read_modbus_command->registerByteNum = parseIntField(paramString, "\"registerByteNum\":");
        if (device->params->node_read_modbus_command == NULL)
        {
            device->params->node_read_modbus_command = read_modbus_command;
        }
        else
        {
            READ_MODBUS_COMMAND *current = device->params->node_read_modbus_command;
            while (current->nextParams != NULL)
            {
                current = current->nextParams;
            }
            current->nextParams = read_modbus_command;
        }
			}
        break;
    default:
        break;
    }
}
void addCommandListParams(char *paramString, DEVICE_PARAMS *device)
{
	
 	WRITE_MODBUS_COMMAND *write_modbus_command=malloc(sizeof(WRITE_MODBUS_COMMAND));
	parseStringField(paramString,"\"identifier\":\"",(char *)&write_modbus_command->keyword);
	write_modbus_command->registerByteNum = parseIntField(paramString, "\"registerByteNum\":");
	write_modbus_command->functionCode=parseIntField(paramString, "\"wFunctionCode\":");
	write_modbus_command->slaveAddress=parseIntField(paramString, "\"slaveAddress\":");
	write_modbus_command->registerAddress = parseIntField(paramString, "\"registerAddress\":");
	if(device->params->node_write_modbus_command == NULL)
	{
		device->params->node_write_modbus_command=write_modbus_command;
	}
	else
	{
		WRITE_MODBUS_COMMAND *current=device->params->node_write_modbus_command;
    while (current->nextParams != NULL)
    {
      current = current->nextParams;
    }
    current->nextParams = write_modbus_command;		
	}
}
// ȡintûȡ򷵻-1ȡȷֵ
int parseIntField(const char *data, const char *field)
{
    char *ptr = strstr(data, field) + strlen(field);
    int value;
    value = strtol(ptr, &ptr, 10);
    return value;
}
/*

*/
// ȡstringַ
void parseStringField(const char *data, const char *field, char *value)
{
		if(strstr(data, field)==NULL)
		{
			value=NULL;
		}
    char *ptr = strstr(data, field) + strlen(field);
    sscanf(ptr, "%[^\"],", value);
}